package com.gic.haoban.manage.api.service;

import com.gic.api.base.commons.JSONResponse;
import com.gic.api.base.commons.Page;
import com.gic.haoban.base.api.common.BasePageInfo;
import com.gic.haoban.base.api.common.ServiceResponse;
import com.gic.haoban.manage.api.dto.*;

import java.util.Date;
import java.util.List;

public interface MemberUnionidRelatedApiService {

    /**
     * 根据导购导购微信id和会员id查询关联关系
     *
     * @param wxUserId : 导购微信id
     * @param memberId : 会员id
     * @return : 返回导购与会员关联关系
     */
	ExternalClerkRelatedDTO getByWxUserIdMemberId(String wxUserId, String memberId);

	MemberUnionidRelatedDTO getByUnionId(String staffId, String memberId);

	String addMemberUnionidRelated(MemberUnionidRelatedDTO dto);

	void delMemberUnionidRelated(MemberUnionidRelatedDTO dto);

    /**
     * 修改
     *
     * @param dto
     */
    void editMemberUnionidRelated(MemberUnionidRelatedDTO dto);

    /**
	 * 处理外部联系人异步
	 * "routerName": "dealQywxExternalUserMq"
	 *
	 * @param params
	 */
    void dealQywxExternalUser(String params);

	ExternalClerkRelatedDTO getByMemberId(String staffId, String memberId);

	List<MemberUnionidRelatedDTO> getByWxUserIdAndWxEnterpriseId(String wxUserId, String wxEnterpriseId);

	List<MemberUnionidRelatedDTO> listByEnterpriseIdAndDate(String enterpriseId, Date date);

    /**
     * 查看是否可以跳转会员详情的会员列表
     *
     * @param externalUserid
     * @param wxUserId
     * @param storeId
     * @return
     */
    List<MemberStoreDTO> listByExTernalUseridAndWxUserId(String externalUserid, String wxUserId, String storeId);

	String add(String wxEnterpriseId, String selfExternalUserId, String userId1, String storeId);

	void freshWxFrend(String wxEnterpriseId, String wxUserId, String storeId);

	void cleanByCid(String cid);

	Page<MemberUnionidRelatedDTO> pageMemberUnionByParams(List<String> userIdList, List<String> sendMemberIds,
														  String enterpriseId, BasePageInfo pageInfo);

	String sendMessage(String wxEnterpriseId, String userId, List<String> extendUserList, String materialId);

	/**
	 * 创建企业群发, 支出素材批量发送
	 *
	 * @param wxEnterpriseId : 微信企业id
	 * @param userId         : 用户id
	 * @param extendUserList : 发送的用户id
	 * @param materialIdList : 素材id列表
	 * @return : 返回群发执行结果
	 */
	JSONResponse sendMessage(String wxEnterpriseId, String userId, List<String> extendUserList, List<String> materialIdList);

	/**
	 * 获取群发成员发送任务列表
	 *
	 * @param wxEnterpriseId : 微信企业id
	 * @param wxMessageId    : 消息id
	 * @param cursor         : 分页游标
	 * @return : 返回请求结果
	 */
	JSONResponse taskExternalMessage(String wxEnterpriseId, String wxMessageId, String cursor);

	/**
	 * 获取企业群发成员执行结果
	 *
	 * @param wxEnterpriseId : 微信企业id
	 * @param wxMessageId    : 消息id
	 * @param cursor         : 分页游标
	 * @param userId         : 用户id
	 * @return : 返回请求结果
	 */
	JSONResponse resultExternalMessage(String wxEnterpriseId, String wxMessageId, String cursor, String userId);

	JSONResponse getMessageStatus(String wxEnterpriseId, String wxMessageId);

	List<MemberUnionidRelatedDTO> getByWxUserIdListAndWxEnterpriseId(List<String> userIdList, String wxEnterpriseId);

	String addMemberUnionidRelatedNew(MemberUnionidRelatedDTO dto);

	void mqFreshWxFrend(String res);

	void cleanNoExsitFriend(String wxEnterpriseId,String wxUserId,String resWes);

	List<String> listSelfExterialList(String wxEnterpriseId,String wxUserId);

	List<String> listExterialList(String wxEnterpriseId, String wxUserId);

	ExternalUserDTO getCorpSelfExternalUseridInfo(String wxEnterpriseId,String wxUserId, String externalUserId);

	String addExternal(ExternalUserDTO dto);

	String addFriendExternal(ExternalUserDTO dto);

	ExternalUserDTO getExternalUseridInfo(String wxEnterpriseId, String wxUserId, String externalUserId);

	/**
	 * 清理外部联系人
	 *
	 * @param wxEnterpriseId
	 * @param wxUserId
	 * @param externalUserIds
	 */
	void cleanNoExsitFriendNew(String wxEnterpriseId, String wxUserId, List<String> externalUserIds);

	/**
	 * 根据会员的unionid 获取好友导购列表
	 *
	 * @param enterpriseId
	 * @param unionId
	 * @return
	 */
	ServiceResponse<List<FriendStoreInfoDTO>> listFriendClerkByMemberUnionid(String enterpriseId, String unionId);

	/**
	 * 根据企业内部外部联系人id 获取关联关系
	 *
	 * @param wxEnterpriseId
	 * @param wxUserId
	 * @param selfExternalUserId
	 * @return
	 */
	MemberUnionidRelatedDTO getExternalUseridInfoBySelfExternalUserId(String wxEnterpriseId, String wxUserId, String selfExternalUserId);

}
