package com.gic.haoban.manage.web.controller.test;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.gic.api.base.commons.Page;
import com.gic.commons.util.EntityUtil;
import com.gic.haoban.base.api.common.BasePageInfo;
import com.gic.haoban.common.utils.CheckContainUtil;
import com.gic.haoban.common.utils.HaobanResponse;
import com.gic.haoban.manage.api.dto.TestDTO;
import com.gic.haoban.manage.api.enums.QuartzEnum;
import com.gic.haoban.manage.api.service.TestApiService;
import com.gic.haoban.manage.api.service.TestService;
import com.gic.haoban.manage.web.controller.WebBaseController;
import com.gic.haoban.manage.web.errCode.HaoBanErrCode;
import com.gic.haoban.manage.web.qo.TestQo;
import com.gic.haoban.manage.web.vo.TestVo;
import com.gic.sharing.core.service.api.service.MqApiService;
import org.apache.commons.lang3.StringUtils;
import org.slf4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;

import java.util.List;
import java.util.Map;

import static org.slf4j.LoggerFactory.getLogger;

/**
 * Created 2018/12/17.
 *
 * @author hua
 */
@Controller
@RequestMapping("/test")
public class TestController extends WebBaseController {

    private static final Logger logger = getLogger(TestController.class);
    @Autowired
    private TestApiService testApiService;

    @Autowired
    private MqApiService mqApiService;
//
//    @RequestMapping("/testList")
//    @ResponseBody
//    public HaobanResponse testList(String id, BasePageInfo info) {
//        HaoBanErrCode errCode = HaoBanErrCode.ERR_1;
//        Page<TestDTO> testDTOPage = testService.queryPage(info);
//        return resultResponse(errCode, testDTOPage);
//    }
//
//    @RequestMapping("/imcallback")
//    @ResponseBody
//    public JSONObject imcallback(@RequestBody JSONObject msg) {
//        System.out.println(msg);
//        System.out.println(msg.toJSONString());
//        String rest = "{\n" +
//                "    \"ActionStatus\": \"OK\",\n" +
//                "    \"ErrorInfo\": \"\",\n" +
//                "    \"ErrorCode\": 0 // 0 为允许发言\n" +
//                "}";
//        return JSONObject.parseObject(rest);
//    }
//
//
//    @RequestMapping("/testListVo")
//    @ResponseBody
//    public HaobanResponse testListVo(TestQo qo, BasePageInfo info) {
//        HaoBanErrCode errCode = HaoBanErrCode.ERR_1;
//        String s = CheckContainUtil.checkAttr(qo);
//        if (s != null) {
//            System.out.println("缺少参数");
//            errCode = HaoBanErrCode.ERR_5;
//            return resultResponse(errCode);
//        }
//        Page<TestDTO> testDTOPage = testService.queryPage(info);
//        List<TestVo> res = EntityUtil.changeEntityListByJSON(TestVo.class, testDTOPage.getResult());
//        return resultResponse(errCode, res);
//    }

    /**
     * 创建定时器
     *
     * @return
     */
    @RequestMapping("/create-quarter")
    @ResponseBody
    public HaobanResponse testListVo(String key) {
        QuartzEnum quartzEnum = QuartzEnum.getByKey(key);
        if (null == quartzEnum) {
            return resultResponse(HaoBanErrCode.ERR_0);
        }
        testApiService.quartzTaskConvert(quartzEnum.getServiceName(), quartzEnum.getMethod(), quartzEnum.getCron(), quartzEnum.getParams());

        return resultResponse(HaoBanErrCode.ERR_1);
    }

    /**
     * 创建定时器
     *
     * @return
     */
    @RequestMapping("/sharing-import")
    @ResponseBody
    public HaobanResponse sharingImport(String key) {
        if (StringUtils.isBlank(key)) {
            return resultResponse(HaoBanErrCode.ERR_0);
        }
        mqApiService.run(key);
        return resultResponse(HaoBanErrCode.ERR_1);
    }

    /**
     * 创建定时器
     *
     * @return
     */
    @RequestMapping("/sharing-import-batch")
    @ResponseBody
    public HaobanResponse sharingImportBatch(String key) {
        if (StringUtils.isBlank(key)) {
            return resultResponse(HaoBanErrCode.ERR_0);
        }
        JSONArray jsonArray = JSONArray.parseArray(key);
        int num = jsonArray.size();
        int i = 0;
        for (Object obj : jsonArray) {
            i = i + 1;
            logger.info("执行num:" + i + ":total" + num);
            mqApiService.run(JSONObject.toJSONString(obj));
        }
        return resultResponse(HaoBanErrCode.ERR_1);
    }
}
