package com.gic.haoban.manage.service.dao.mapper;

import java.util.Collection;
import java.util.Date;
import java.util.List;

import org.apache.ibatis.annotations.Param;

import com.gic.haoban.manage.service.entity.TabHaobanExternalClerkRelated;
import com.github.pagehelper.Page;

public interface TabHaobanExternalClerkRelatedMapper {
    int deleteByPrimaryKey(String externalClerkRelatedId);

    int insert(TabHaobanExternalClerkRelated record);

    int insertSelective(TabHaobanExternalClerkRelated record);

    TabHaobanExternalClerkRelated selectByPrimaryKey(String externalClerkRelatedId);

    int updateByPrimaryKeySelective(TabHaobanExternalClerkRelated record);

    int updateByPrimaryKey(TabHaobanExternalClerkRelated record);

	TabHaobanExternalClerkRelated selectByClerkIdAndExternalUserId(@Param("clerkId")String clerkId, @Param("externalUserId")String externalUserId);

	void delByUserIdAndExternalUserId(TabHaobanExternalClerkRelated record);

	void delByUserIdAndExternalUserIdBatch(@Param("wxUserId") String wxUserId, @Param("wxEnterpriseId") String wxEnterpriseId, @Param("externalUserIds") List<String> externalUserIds);

	void delByClerkIdAndStaffId(@Param("clerkId")String clerkId, @Param("staffId")String staffId);

    void delByStoreIdAndStaffId(@Param("storeId") String storeId, @Param("staffId") String staffId);

    int delByStoreIds(@Param("storeIds") Collection<String> storeIds);

	void cleanStaffRelated(@Param("wxEnterpriseId")String wxEnterpriseId, @Param("staffIds")List<String> staffIds);

	TabHaobanExternalClerkRelated getByParams(@Param("userId")String userId, @Param("wxEnterpriseId")String wxEnterpriseId, @Param("name")String name, @Param("createTime")String createTime);

	List<TabHaobanExternalClerkRelated> listByExTernalUseridAndWxUserId(@Param("externalUserid")String externalUserid, @Param("userId")String wxUserId);

    List<TabHaobanExternalClerkRelated> listByExTernalUseridAndWxUserIdAllStatus(@Param("wxEnterpriseId") String wxEnterpriseId, @Param("externalUserid") String externalUserid, @Param("userId") String wxUserId);

    List<TabHaobanExternalClerkRelated> listByEnterpriseIdAndDate(@Param("enterpriseId")String enterpriseId,@Param("date")Date date);

	Page<TabHaobanExternalClerkRelated> pageMemberUnionByParams(@Param("userIdList")List<String> userIdList, @Param("sendMemberIds")List<String> sendMemberIds,
			@Param("enterpriseId")String enterpriseId);

	List<TabHaobanExternalClerkRelated> listByWxEnterpriseIdAndWxUserId(@Param("wxUserId")String wxUserId, @Param("wxEnterpriseId")String wxEnterpriseId);

	List<TabHaobanExternalClerkRelated> listByWxEnterpriseIdAndWxUserIds(@Param("userIdList")List<String> userIdList, @Param("wxEnterpriseId")String wxEnterpriseId);

	TabHaobanExternalClerkRelated getByMemberId(@Param("wxUserId")String wxUserId, @Param("memberId")String memberId);

    /**
     * 外部联系人的unionid
     *
     * @param enterpriseId
     * @param unionId
     * @return
     */
    List<TabHaobanExternalClerkRelated> listExternalByUnionId(@Param("enterpriseId") String enterpriseId, @Param("unionId") String unionId);

	/**
	 * 外部联系人的unionid
	 *
	 * @param enterpriseId
	 * @param unionId
	 * @return
	 */
	TabHaobanExternalClerkRelated getClerkExternalByUnionId(@Param("enterpriseId") String enterpriseId, @Param("clerkId") String clerkId, @Param("unionId") String unionId);

    /**
     * @param relationKey
     * @return
     */
    TabHaobanExternalClerkRelated getByRelationKey(@Param("relationKey") String relationKey);

	/**
	 * 列表数据 根据状态 时间倒序
	 *
	 * @param wxEnterpriseId
	 * @param wxUserId
	 * @param statusFlags
	 * @return
	 */
	List<TabHaobanExternalClerkRelated> listByWxEnterpriseIdAndWxUserIdAndStatus(@Param("wxEnterpriseId") String wxEnterpriseId, @Param("wxUserId") String wxUserId, @Param("statusFlags") List<Integer> statusFlags);

	/**
	 * 触达会员 给会员发送
	 *
	 * @param relationKey
	 * @return
	 */
    int pushExternalByRelationKey(@Param("relationKey") String relationKey);

	/**
	 * 获取企业下的关联关系列表
	 *
	 * @param wxEnterpriseId
	 * @param wxUserId
	 * @param enterpriseId
	 * @param externalUserId
	 * @return
	 */
    List<TabHaobanExternalClerkRelated> listExternalClerkByWxUserIdAncExternalUserId(
            @Param("wxEnterpriseId") String wxEnterpriseId, @Param("wxUserId") String wxUserId,
            @Param("enterpriseId") String enterpriseId, @Param("externalUserId") String externalUserId);

	/**
	 * 查询会员在企业下的好友关系
	 * @param memberId
	 * @param wxEnterpriseId
	 * @param enterpriseId
	 * @return
	 */
	List<TabHaobanExternalClerkRelated> listByMemberIdAndWxEnterpriseId(@Param("memberId")String memberId,
																		@Param("wxEnterpriseId") String wxEnterpriseId,
																		@Param("enterpriseId") String enterpriseId);

	/**
	 * 查询会员在企业下的好友关系
	 * @param wxUserId
	 * @param wxEnterpriseId
	 * @param enterpriseId
	 * @return
	 */
	List<TabHaobanExternalClerkRelated> listByWxUserIdAndWxEnterpriseId(@Param("wxUserId")String wxUserId,
																		@Param("wxEnterpriseId") String wxEnterpriseId,
																		@Param("enterpriseId") String enterpriseId);

    /**
     * 获取最新的最近的外部联系人
     *
     * @param externalUserid
     * @param wxUserId
     * @return
     */
    TabHaobanExternalClerkRelated getLastByExTernalUseridAndWxUserIdNoStatus(@Param("wxEnterpriseId") String wxEnterpriseId, @Param("externalUserid") String externalUserid, @Param("wxUserId") String wxUserId);

    /**
     * 根据id 查询列表
     *
     * @param wxEnterpriseId
     * @param ids
     * @return
     */
    List<TabHaobanExternalClerkRelated> listByIds(@Param("wxEnterpriseId") String wxEnterpriseId,
                                                  @Param("ids") List<String> ids);

    /**
     * 根据企业id 查询列表
     *
     * @param wxEnterpriseId
     * @return
     */
    List<String> listMemberIdByEnterpriseId(@Param("wxEnterpriseId") String wxEnterpriseId,
                                            @Param("enterpriseId") String enterpriseId);

	/**
	 * 查询会员在企业下的好友关系 根据会员ids
	 *
	 * @param memberIds
	 * @param wxEnterpriseId
	 * @return
	 */
	List<TabHaobanExternalClerkRelated> listByMemberIds(@Param("memberIds") List<String> memberIds,
														@Param("wxEnterpriseId") String wxEnterpriseId);

	/**
	 * 查询会员在企业下的好友关系memberIds 根据会员ids
	 *
	 * @param memberIds
	 * @param wxEnterpriseId
	 * @return
	 */
	List<String> listMemberIdsByMemberIds(@Param("memberIds") List<String> memberIds,
										  @Param("wxEnterpriseId") String wxEnterpriseId);

	/**
	 * 查询会员在企业下的好友关系 根据会员id
	 *
	 * @param memberId
	 * @return
	 */
	List<TabHaobanExternalClerkRelated> listByMemberId(@Param("memberId") String memberId);

	/**
	 * 查询会员在企业下的好友关系 根据会员id
	 *
	 * @param wxEnterpriseId
	 * @return
	 */
	List<TabHaobanExternalClerkRelated> listByExternalUserId(@Param("wxEnterpriseId") String wxEnterpriseId, @Param("externalUserId") String externalUserId);
}