package com.gic.haoban.manage.service.task;

import org.apache.commons.lang3.StringUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.gic.clerk.api.dto.ClerkDTO;
import com.gic.clerk.api.service.ClerkService;
import com.gic.clerk.api.service.PowerService;
import com.gic.haoban.manage.api.dto.ClerkMainStoreRelatedDTO;
import com.gic.haoban.manage.api.dto.DealParamMqDTO;
import com.gic.haoban.manage.api.dto.ExternalUserDTO;
import com.gic.haoban.manage.api.dto.StaffClerkRelationDTO;
import com.gic.haoban.manage.api.dto.StaffDTO;
import com.gic.haoban.manage.api.enums.PreDealStatusEnum;
import com.gic.haoban.manage.api.enums.PreDealTypeEnum;
import com.gic.haoban.manage.api.enums.SyncTaskStatusEnum;
import com.gic.haoban.manage.api.service.ClerkMainStoreRelatedApiService;
import com.gic.haoban.manage.api.service.MemberUnionidRelatedApiService;
import com.gic.haoban.manage.api.service.StaffApiService;
import com.gic.haoban.manage.service.entity.TabHaobanPreDealLog;
import com.gic.haoban.manage.service.entity.TabHaobanSyncTask;
import com.gic.haoban.manage.service.service.PreDealService;
import com.gic.haoban.manage.service.service.StaffClerkRelationService;
import com.gic.haoban.manage.service.service.SyncTaskService;
import com.gic.member.api.dto.MemberDTO;
import com.gic.member.api.service.MemberOpenCardBusinessService;
import com.gic.redis.data.util.RedisUtil;

@Service
@Deprecated
public class FriendMergeSyncOperation implements BaseSyncOperation{
	private static final Logger logger = LoggerFactory.getLogger(FriendMergeSyncOperation.class);
	@Autowired
	private PreDealService preDealService;
	@Autowired
	private MemberUnionidRelatedApiService memberUnionidRelatedApiService;
	@Autowired
	private SyncTaskService syncTaskService;
	@Autowired
	private ClerkMainStoreRelatedApiService clerkMainStoreRelatedApiService;
	@Autowired
	private StaffApiService staffApiService;
	@Autowired
	private StaffClerkRelationService staffClerkRelationService;
	@Autowired
	private ClerkService clerkService;
	@Autowired
	private PowerService powerService;
	@Autowired
	private MemberOpenCardBusinessService memberOpenCardBusinessService;
	@Override
	public void dealSingleByMq(DealParamMqDTO dealParamMqDTO, TabHaobanPreDealLog dataPre) {
		String reason = "";
		boolean dealFlag = true;
		String wxUserId = dataPre.getpDataId();
		String wxEnterpriseId = dataPre.getWxEnterpriseId();
		String taskId = dealParamMqDTO.getTaskId();
		String key = dataPre.getDataId();
		try {
			String dataContent = dataPre.getDataContent();
			ExternalUserDTO pojo = JSON.parseObject(dataContent, ExternalUserDTO.class);
			StaffDTO staff = staffApiService.selectByUserIdAndEnterpriseId(wxUserId, wxEnterpriseId);
			if(staff == null){
				preDealService.updateStatusByDataId(taskId, key, PreDealStatusEnum.exception.getVal(), "成员不存在");
				checkDepartmentTask(taskId);
				return;
			}
			ClerkMainStoreRelatedDTO mainStore = clerkMainStoreRelatedApiService.getWxEnterpriseIdAndStaffId(wxEnterpriseId, staff.getStaffId());
			if(mainStore == null){
				preDealService.updateStatusByDataId(taskId, key, PreDealStatusEnum.exception.getVal(), "主门店不存在");
				checkDepartmentTask(taskId);
				return;
			}
			StaffClerkRelationDTO staffClerkRelationDTO = staffClerkRelationService.getOneBindByStoreId(staff.getStaffId(),mainStore.getStoreId());
			if(staffClerkRelationDTO == null){
				preDealService.updateStatusByDataId(taskId, key, PreDealStatusEnum.exception.getVal(), "未绑定导购");
				checkDepartmentTask(taskId);
				return;
			}
			if(pojo == null){
				dealException(taskId, key, null, "好友不存在");
				checkDepartmentTask(taskId);
				return;
			}
			pojo.setWxEnterpriseId(wxEnterpriseId);
			pojo.setEnterpriseId(staffClerkRelationDTO.getEnterpriseId());
			pojo.setStoreId(mainStore.getStoreId());
			pojo.setClerkId(staffClerkRelationDTO.getClerkId());
			pojo.setWxUserId(wxUserId);
			pojo.setStaffId(staffClerkRelationDTO.getStaffId());
			String externalUserId = pojo.getExternalUserId();
			ExternalUserDTO p = memberUnionidRelatedApiService.getExternalUseridInfo(wxEnterpriseId, wxUserId, externalUserId);	
			if(p == null){
				dealException(taskId, key, null, "好友不存在");
				checkDepartmentTask(taskId);
				return;
			}
			pojo.setAvatar(p.getAvatar());
			//新增导购和外部联系人关系
			String clerkCode = staffClerkRelationDTO.getClerkCode();
			ClerkDTO clerk = clerkService.getClerkByClerkCode(staffClerkRelationDTO.getEnterpriseId(), clerkCode);
			if(clerk == null){
				preDealService.updateStatusByDataId(taskId, key, PreDealStatusEnum.exception.getVal(), "导购不存在");
				checkDepartmentTask(taskId);
				return;
			}
			String qrcodeParam = clerk.getQrcodeParam();
			if(StringUtils.isBlank(qrcodeParam)){
				powerService.saveClerkQrCode(clerk.getClerkId());
				clerk = clerkService.getClerkByClerkCode(staffClerkRelationDTO.getEnterpriseId(), clerkCode);
				qrcodeParam = clerk.getQrcodeParam();
			}
			if(StringUtils.isBlank(qrcodeParam)){
				preDealService.updateStatusByDataId(taskId, key, PreDealStatusEnum.exception.getVal(), "导购码不存在");
				checkDepartmentTask(taskId);
				return;
			}
			MemberDTO member = null;
			if(clerk != null && StringUtils.isNotBlank(qrcodeParam)&&StringUtils.isNotBlank(pojo.getUnionId())){
				 member = memberOpenCardBusinessService.getMemberByQywxChannelParam(staffClerkRelationDTO.getEnterpriseId(),pojo.getUnionId(),"",pojo.getName(),pojo.getAvatar(),qrcodeParam);
			}
			if(member == null){
				preDealService.updateStatusByDataId(taskId, key, PreDealStatusEnum.exception.getVal(), "会员不存在");
				checkDepartmentTask(taskId);
				return;
			}
			pojo.setMemberId(member.getMemberId());
			String res = memberUnionidRelatedApiService.addExternal(pojo);
			if(StringUtils.isBlank(res)){
				dealSuccess(dealParamMqDTO.getTaskId(), dataPre.getDataId(), null, null);
			}else{
				dealException(dealParamMqDTO.getTaskId(), dealParamMqDTO.getData(), dataPre.getEnterpriseId(), "好友不存在");
			}
		} catch (Exception e) {
			e.printStackTrace();
			logger.info("同步失败：{},{}", JSONObject.toJSONString(dataPre),e);
            reason = "合并处理异常";
            dealFlag = false;
		}finally {
			if (!dealFlag) {
               dealException(dealParamMqDTO.getTaskId(), dealParamMqDTO.getData(), dataPre.getEnterpriseId(), reason);
           }
			checkDepartmentTask(taskId);		
		}
//		
	}

	@Override
	public void dealException(String taskId, String dataId, String enterpriseId, String reason) {
		preDealService.updateStatusByDataId(taskId, dataId, PreDealStatusEnum.exception.getVal(), reason);
		
	}

	@Override
	public void dealSuccess(String taskId, String dataId, String enterpriseId, String wxEnterpriseId) {
		preDealService.updateStatusByDataId(taskId, dataId, PreDealStatusEnum.computed.getVal(), "成功");
		
	}

	@Override
	public void checkDepartmentTask(String taskId) {
		boolean b = preDealService.checkTask(taskId, PreDealTypeEnum.friend_merge.getVal());
        if (!b) {
            return;
        }
        logger.info("好友合并成功:{}", taskId);
        int errorCount = preDealService.countByTaskId(taskId, PreDealTypeEnum.friend_merge.getVal(), 3);
        int errorSelfCount = preDealService.countByTaskId(taskId, PreDealTypeEnum.self_friend.getVal(), 3);
        int errorFriendCount = preDealService.countByTaskId(taskId, PreDealTypeEnum.friend.getVal(), 3);
        if(errorCount > 0 || errorFriendCount > 0 || errorSelfCount > 0){
        	syncTaskService.updateTaskStatus(taskId, SyncTaskStatusEnum.exception_compute.getVal());
        }else{
        	syncTaskService.updateTaskStatus(taskId, SyncTaskStatusEnum.compute.getVal());
        }
	}

}
