package com.gic.haoban.manage.service.task;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Set;
import java.util.stream.Collectors;

import org.apache.commons.collections.CollectionUtils;
import org.apache.commons.lang3.StringUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.gic.commons.util.GICMQClientUtil;
import com.gic.haoban.manage.api.dto.ClerkMainStoreRelatedDTO;
import com.gic.haoban.manage.api.dto.DealParamMqDTO;
import com.gic.haoban.manage.api.dto.ExternalUserDTO;
import com.gic.haoban.manage.api.dto.StaffClerkRelationDTO;
import com.gic.haoban.manage.api.dto.StaffDTO;
import com.gic.haoban.manage.api.enums.PreDealStatusEnum;
import com.gic.haoban.manage.api.enums.PreDealTypeEnum;
import com.gic.haoban.manage.api.enums.SyncTaskStatusEnum;
import com.gic.haoban.manage.api.service.ClerkMainStoreRelatedApiService;
import com.gic.haoban.manage.api.service.MemberUnionidRelatedApiService;
import com.gic.haoban.manage.api.service.StaffApiService;
import com.gic.haoban.manage.service.entity.TabHaobanPreDealLog;
import com.gic.haoban.manage.service.pojo.ExternalUserPojo;
import com.gic.haoban.manage.service.service.PreDealService;
import com.gic.haoban.manage.service.service.StaffClerkRelationService;
import com.gic.haoban.manage.service.service.SyncTaskService;
import com.gic.mq.sdk.GicMQClient;
import com.gic.redis.data.util.RedisUtil;

@Service
@Deprecated
public class FriendSyncOperation implements BaseSyncOperation {
	private static final Logger logger = LoggerFactory.getLogger(FriendSyncOperation.class);
	@Autowired
	private PreDealService preDealService;
	@Autowired
	private MemberUnionidRelatedApiService memberUnionidRelatedApiService;
	@Autowired
	private SyncTaskService syncTaskService;
	@Autowired
	private ClerkMainStoreRelatedApiService clerkMainStoreRelatedApiService;
	@Autowired
	private StaffApiService staffApiService;
	@Autowired
	private StaffClerkRelationService staffClerkRelationService;
	@Override
	public void dealSingleByMq(DealParamMqDTO dealParamMqDTO, TabHaobanPreDealLog dataPre) {
		String reason = "";
		boolean dealFlag = true;
		String wxEnterpriseId = dataPre.getWxEnterpriseId();
		String wxUserId = dataPre.getpDataId();
		String taskId = dealParamMqDTO.getTaskId();
		String externalUserId = dataPre.getDataContent();
		ExternalUserDTO pojo = memberUnionidRelatedApiService.getExternalUseridInfo(wxEnterpriseId, wxUserId, externalUserId);
		if(pojo == null){
			preDealService.updateStatusByDataId(taskId, dataPre.getDataId(), PreDealStatusEnum.exception.getVal(), "好友不存在");
			checkStaffTask(taskId, wxUserId);
			return;
		}
		JSONObject json = new JSONObject();
		json.put("name", pojo.getName());
		json.put("externalUserId", pojo.getExternalUserId());
		json.put("addCreateTime", pojo.getAddCreateTime());
		dealSuccess(taskId, dataPre.getDataId(),JSON.toJSONString(json),wxEnterpriseId);
		try {
			checkStaffTask(taskId, wxUserId);
		} catch (Exception e) {
			e.printStackTrace();
			logger.info("同步失败：{},{}", JSONObject.toJSONString(dataPre),e);
            reason = "第三方好友处理异常";
            dealFlag = false;
		}finally {
			if (!dealFlag) {
               dealException(dealParamMqDTO.getTaskId(), dataPre.getDataId(), dataPre.getEnterpriseId(), reason);
           } 
		}
	}

	@Override
	public void dealException(String taskId, String dataId, String enterpriseId, String reason) {
		preDealService.updateStatusByDataId(taskId, dataId, PreDealStatusEnum.exception.getVal(), reason);
	}

	@Override
	public void dealSuccess(String taskId, String dataId, String dataContent, String wxEnterpriseId) {
		preDealService.updateFriendStatusByDataId(taskId, dataId, PreDealStatusEnum.computed.getVal(), "成功",dataContent);

	}

	public void checkStaffTask(String taskId,String wxUserId) {
		boolean flag =  preDealService.checkStaffTaskByTaskIdAndPDataId(taskId,wxUserId);
		logger.info("checkStaffTask={}",flag);
		if(flag){
			List<TabHaobanPreDealLog> list = preDealService.listByPDataIdAndTaskId(taskId, wxUserId);
			if(CollectionUtils.isNotEmpty(list)){
				Map<String,ExternalUserDTO> map = new HashMap<>();
				List<TabHaobanPreDealLog> dealLogList = new ArrayList<>();
				for (TabHaobanPreDealLog tabHaobanPreDealLog : list) {
					String dataContent = tabHaobanPreDealLog.getDataContent();
					if(StringUtils.isNotBlank(dataContent) && dataContent.startsWith("{")){
						ExternalUserDTO json = JSON.parseObject(dataContent, ExternalUserDTO.class);
						
						String addCreateTime = json.getAddCreateTime();
						String name = json.getName();
						String key = name +"-"+wxUserId +"-"+ addCreateTime;
						String unionId = json.getUnionId();
						String wxEnterpriseId = tabHaobanPreDealLog.getWxEnterpriseId();
						String externalUserId = json.getExternalUserId();
						
						ExternalUserDTO dto = map.get(key);
						if(dto != null){
							if(tabHaobanPreDealLog.getDataType() == PreDealTypeEnum.self_friend.getVal()){
								dto.setUnionId(unionId);
							}else if(tabHaobanPreDealLog.getDataType() == PreDealTypeEnum.friend.getVal()){
								dto.setExternalUserId(externalUserId);
							}
							TabHaobanPreDealLog dealLog = new TabHaobanPreDealLog();
				            dealLog.setDataId(key);
				            dealLog.setpDataId(wxUserId);
				            dealLog.setDataType(PreDealTypeEnum.friend_merge.getVal());
				            dealLog.setStatusFlag(0);
				            dealLog.setTaskId(taskId);
				            dealLog.setDataContent(JSONObject.toJSONString(dto));
				            dealLog.setWxEnterpriseId(wxEnterpriseId);
				            dealLogList.add(dealLog);
						}else{
							map.put(key, json);
						}
					}
				}
				logger.info("dealLogList={}",JSON.toJSONString(dealLogList));
				if(CollectionUtils.isNotEmpty(dealLogList)){
					preDealService.insert(dealLogList);
					HashSet<String> hashSet = (HashSet<String>) dealLogList.stream().map(TabHaobanPreDealLog::getDataId).collect(Collectors.toSet());
			        dealDepartmentToMq(taskId, hashSet, SyncTaskStatusEnum.merge_friend_sync);
				}
			}
		}
	}

	@Override
	public void checkDepartmentTask(String taskId) {
		
	}
	
	/**
     * 放入mq处理部门数据
     *
     * @param taskId
     * @param dealList
     */
    private void dealDepartmentToMq(String taskId, Set<String> dealList, SyncTaskStatusEnum syncTaskStatusEnum) {
        //预处理分组任务
        syncTaskService.updateTaskStatus(taskId, syncTaskStatusEnum.getVal());
        dealList.forEach(relationId -> {
            DealParamMqDTO dealParamMqDTO = new DealParamMqDTO();
            dealParamMqDTO.setTaskId(taskId);
            dealParamMqDTO.setData(relationId);
            dealParamMqDTO.setType(syncTaskStatusEnum.getVal());
            GicMQClient clientInstance = GICMQClientUtil.getClientInstance();
            try {
                clientInstance.sendMessage("departmentSyncDealMq", JSONObject.toJSONString(dealParamMqDTO));
            } catch (Exception e) {
                logger.info("发送失败:{},{}", taskId, relationId);
                e.printStackTrace();
            }
        });
    }

}
