package com.gic.haoban.manage.web.errCode;

/**
 * Created by fudh on 2018/3/4.
 */
public enum HaoBanErrCode {
    //update by 牧峰 2018-7-25 19:58:06
    /**
     * 操作失败
     */
    ERR_0(0, "操作失败"),
    /**
     * 操作成功
     */
    ERR_1(1, "操作成功"),
    /**
     * 缺少参数
     */
    ERR_2(2, "缺少参数"),
    /**
     * 系统异常
     */
    ERR_3(3, "系统异常"),
    /**
     * 登录异常
     */
    ERR_4(4, "登录异常"),
    /**
     * 输入参数错误
     */
    ERR_5(5, "输入参数错误"),
    /**
     * 该企业登录用户不存在
     */
    ERR_6(6, "该企业登录用户不存在"),
    /**
     * 该用户缺少该权限
     */
    ERR_7(7, "该用户缺少该权限"),
    /**
     * 查无数据
     */
    ERR_8(8, "查无数据"),
    /**
     * 非法操作
     */
    ERR_9(9, "非法操作"),

    /**
     * 用户已经登录
     */
    ERR_10(10, "用户已经登录"),

    /**
     * 验证码发送失败
     */
    ERR_11(11, "验证码发送失败"),

    /**
     * 验证码校验失败
     */
    ERR_12(12, "验证码校验失败"),
    
    ERR_13(13, "验证码发送失败"),
    
    ERR_20(20, "区号或者手机号码不合法"),
    
    ERR_21(21, "验证码已过期或者错误"),
    
    ERR_22(22, "验证码一分钟只能请求一次"),
    
    ERR_10008(10008,"请不要过于频繁点击"),

    /**
     * 员工档案模块
     */
    ERR_400001(400001, "通讯录中不存在"),
    ERR_400002(400002, "企业不存在"),
    ERR_400003(400003, "品牌不存在"),
    ERR_400004(400004, "excel文件格式有问题"),
    ERR_400005(400005, "选择文件错误"),
    ERR_400006(400006, "模板内容为空"),
    ERR_400007(400007, "总列数与模板不一致"),
    ERR_400008(400008, "导入的title跟模板title描述不匹配"),
    ERR_400009(400009, "共享企业或取得共享企业已达最大数量"),
    ERR_400010(400010, "不是该企业无权限添加"),
    ERR_400011(400011, "添加共享企业重复"),
    ERR_400012(400012, "员工档案不存在"),
    ERR_400013(400013, "没有查看共享通讯录的权限"),
    ERR_400014(400014, "仅支持认证企业建立企业通讯录共享"),
    ERR_400015(400015, "数据为空"),
    ERR_400016(400016, "提交人不存在"),
    ERR_400017(400017, "成员不存在"),
    ERR_400018(400018, "已有待审核的门店字段信息提交，请等待审核完再提交"),
    ERR_400019(400019, "门店面积不合法"),
    ERR_400020(400020, "门店图片不能为空"),

    /**
     * 文件不存在
     */
    ERR_20001(201, "文件不存在"),
    /**
     * 文件格式错误
     */
    ERR_20002(202, "文件格式错误"),
    /**
     * 文件读取失败
     */
    ERR_20003(203, "文件读取失败"),
    /**
     * 文件列数错误
     */
    ERR_20004(204, "文件列数错误"),


    //登录权限
    ERR_30001(30001, "请添加权限"),
    ERR_30002(30002, "二维码超时，请刷新二维码"),
    ERR_30003(30003, "您没有管理员权限"),
    ERR_30004(30004, "登录超时，请重新登录"),
    ERR_30005(30005, "用户不存在"),
    ERR_30006(30006, "用户名或密码错误"),
    ERR_30007(30007, "未设置密码，请先设置密码"),
    ERR_30008(30008, "超级管理员不存在"),

    //角色
    ERR_40001(40001, "角色异常"),
    ERR_500002(500002, "角色下存在管理员，请移除管理员!"),
    /**
     * 办理离职
     */
    ERR_100001(100001, "办理离职成功"),
    ERR_100002(100002, "正在等待审核"),
    ERR_100003(100003, "办理转正成功"),
    ERR_100004(100004, "已经离职"),
    ERR_100005(100005, "已经转正"),
    ERR_100006(100006, "店长不能办理离职"),
    ERR_100007(100007, "管理员不能办理离职"),
    ERR_100008(100008, "与gic关联不能办理离职"),
    /**
     * 通讯录模块
     */
    ERR_111111(111111, "用户已存在"),
    ERR_111112(111112, "层级不能超过6"),
    ERR_111113(111113, "店铺已存在"),
    ERR_111114(111114, "该员工已在行政架构下"),
    ERR_111115(1111115, "该员工已在门店架构下"),
    ERR_111116(111116, "code不能为空"),
    ERR_111117(111117, "code已存在"),
    ERR_111118(111118, "部门不能为空"),
    ERR_111119(111119, "门店不能为空"),
    ERR_111120(111120, "手机不能为空"),
    ERR_111121(111121, "姓名不能为空"),
    ERR_111122(111122, "门店名称不能为空"),
    ERR_111123(111123, "店长名称不能为空"),
    ERR_111124(111124, "店长电话不能为空"),
    ERR_111125(111125, "门店编号不能为空"),
    ERR_111126(111126, "门店编号已存在"),
    ERR_111127(111127, "该部门下存在部门不让删除"),
    ERR_111128(111128, "该部门下存在店铺不让删除"),
    ERR_111129(111129, "该部门下存在人员不让删除"),
    ERR_111130(111130, "品牌不能修改"),
    ERR_111131(111131, "店长不能删除"),
    ERR_111132(111132, "管理员不能删除"),
    ERR_111133(111133, "品牌名称不能重复"),

    ERR_111134(111134, "未认证企业只能导入30家门店"),
    ERR_111135(111135, "未认证企业只能导入200个用户"),
    ERR_111136(111136, "部门名称不能重复"),
    ERR_111137(111137, "其他管理员正在导入"),

    ERR_111138(111138, "企业每次最多只能导入800个用户"),
    ERR_111139(111134, "未认证企业只能导入200家门店"),
    ERR_111140(111140,"已经与gic关联，无法操作"),
    ERR_111141(111141,"门店面积不能超过999999"),
    
    ERR_111142(111142,"品牌不能为空"),
    ERR_111143(111143,"code或者手机号码已存在"),
    
    ERR_111144(111144,"该企业或品牌已关联"),
    ERR_111145(111145, "已经解绑过了"),
    ERR_111146(111146, "门店不存在"),

    // 企业设置
    ERR_200001(200001, "员工不存在"),
    ERR_200002(200002, "非当前登录企业员工"),

    ERR_500001(500001, "该企业没关联好办"),
    ERR_500003(500003, "企业corpid不对应，需要重新登录传code"),
    ERR_600001(600001, "成员不存在,请联系管理员后台授权通讯录权限"),
    ERR_600002(600002, "无手机号"),
    
    ERR_10004(10004,"成员名称不能为空"),
    ERR_10005(10005,"成员已存在"),
    ERR_10006(10006,"成员不存在"),
    ERR_10007(10007, "本月已经设置过主导购"),
    ERR_10031(10031, "本月已经设置过主门店"),
    
    ERR_10009(10009,"门店不存在"),
    ERR_10010(10010,"gic新增失败"),
    ERR_10011(10011,"每月最多可刷新4次"),
    ERR_10012(10012,"手机号格式不正确"),
    ERR_10013(10013,"code已经存在"),
    ERR_10014(10014,"请输入手机号"),
    ERR_10015(10015,"素材不存在"),

    ERR_10016(10016,"导购不存在"),

    ERR_10017(10017,"审核记录不存在"),

    ERR_10018(10018,"审核记录已存在"),

    ERR_10019(10019,"没有配置secret"),

    ERR_10020(10020,"该用户已在该门店绑定过code"),

    ERR_10021(10021,"待审核中存在code或该手机号"),

    ERR_10022(10022, "已有刷新在执行中,请不要重复刷新"),

    ERR_11122(11122,"手机号已存在"),

    ERR_11123(11123, "请到好办端刷新企业微信好友"),

    ERR_11124(11124, "好办小程序配置没有配置对应的小程序"),

    ERR_11125(11125, "该企业与gic在同一开平，无需手动关联好友会员"),

    ERR_999(999, "操作失败"),
    ERR_DEFINE(-888, "自定义错误"),
    
    ERR_OTHER(-999, "未知错误code");

    private int code;
    private String msg;

    private HaoBanErrCode(int code, String value) {
        this.code = code;
        this.msg = value;
    }

    public static HaoBanErrCode getValue(int code) {
        for (HaoBanErrCode sec : HaoBanErrCode.values()) {
            if (code == sec.getCode()) {
                return sec;
            }
        }
        ERR_OTHER.setMsg("未知错误code：" + code);
        return ERR_OTHER;
    }

    public int getCode() {
        return code;
    }

    public void setCode(int code) {
        this.code = code;
    }

    public String getMsg() {
        return msg;
    }

    public void setMsg(String msg) {
        this.msg = msg;
    }
}
